/*
 * 客小爽操作视频列表
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class AppVideoListController : BaseController
    {
        public AppVideoListController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 客小爽操作视频列表列表

        /// <summary>
        /// 根据条件查询客小爽操作视频列表列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(AppVideoList data, string right, string VideoId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 根据条件查询客小爽操作视频列表列表

        /// <summary>
        /// 客小爽操作视频列表列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(AppVideoList data, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("VideoId", "1");

            Fields.Add("Title", "1"); //标题


            string condition = " and Status>-1";


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("AppVideoList", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //视频分类Id
                dic["VideoId"] = RelationClass.GetAppVideoInfo(int.Parse(dic["VideoId"].ToString()));

            }
            return Json(obj);
        }

        #endregion

        #region 增加客小爽操作视频列表

        /// <summary>
        /// 增加或修改客小爽操作视频列表信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right, string VideoId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.VideoId = VideoId;


            return View();
        }

        #endregion

        #region 增加客小爽操作视频列表

        /// <summary>
        /// 增加或修改客小爽操作视频列表信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(AppVideoList data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("VideoId", data.VideoId);

            Fields.Add("Title", data.Title); //标题
            Fields.Add("VideoUrl", data.VideoUrl); //视频地址
            Fields.Add("Remark", data.Remark); //备注
            Fields.Add("BgPic", data.BgPic); //背景图

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("AppVideoList", Fields, 0);
            AddSysLog(data.Id.ToString(), "AppVideoList", "add");
            db.SaveChanges();

            SetRedis(data.VideoId);

            return "success";
        }

        #endregion

        #region 修改客小爽操作视频列表

        /// <summary>
        /// 增加或修改客小爽操作视频列表信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, string VideoId, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.VideoId = VideoId;


            AppVideoList editData = db.AppVideoList.FirstOrDefault(m => m.Id == Id) ?? new AppVideoList();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改客小爽操作视频列表

        /// <summary>
        /// 增加或修改客小爽操作视频列表信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(AppVideoList data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("VideoId", data.VideoId);

            Fields.Add("Title", data.Title); //标题
            Fields.Add("VideoUrl", data.VideoUrl); //视频地址
            Fields.Add("Remark", data.Remark); //备注
            Fields.Add("BgPic", data.BgPic); //背景图

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("AppVideoList", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "AppVideoList", "update");
            db.SaveChanges();

            SetRedis(data.VideoId);

            return "success";
        }

        #endregion

        #region 删除客小爽操作视频列表信息

        /// <summary>
        /// 删除客小爽操作视频列表信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "AppVideoList", "del");
            List<int> VideoIds = new List<int>();
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                AppVideoList item = db.AppVideoList.FirstOrDefault(m => m.Id == id) ?? new AppVideoList();
                if (!VideoIds.Contains(item.VideoId))
                {
                    VideoIds.Add(item.VideoId);
                }
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("AppVideoList", Fields, id);
            }
            db.SaveChanges();

            foreach (int VideoId in VideoIds)
            {
                SetRedis(VideoId);
            }

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "AppVideoList", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("AppVideoList", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "AppVideoList", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("AppVideoList", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("AppVideoList", Sort, Id);

            AddSysLog(Id.ToString(), "AppVideoList", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.AppVideoList.Add(new AppVideoList()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "AppVideoList", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(AppVideoList data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Title", "1"); //标题


            string condition = " and Status>-1";


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("AppVideoList", Fields, "Id desc", "0", 1, 20000, condition, "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //视频分类Id
                dic["VideoId"] = RelationClass.GetAppVideoInfo(int.Parse(dic["VideoId"].ToString()));

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "AppVideoList", "ExportExcel");
            return Json(result);
        }

        #endregion



        #region 设置缓存

        private void SetRedis(int VideoId)
        {
            RedisDbconn.Instance.Clear("AppVideoList");
            List<AppVideoList> list = db.AppVideoList.Where(m => m.Status > -1 && m.VideoId == VideoId).OrderByDescending(m => m.Sort).ThenByDescending(m => m.Id).ToList();
            foreach (AppVideoList sub in list)
            {
                RedisDbconn.Instance.AddList("AppVideoList", sub);
            }
        }

        #endregion

    }
}
